(function( d ) {
   'use strict';
   var no =d.getElementById('no') , 
       gt = d.getElementById( 'get' );

   d.getElementById( 'testForm' ).reset();   
   d.getElementById( 'max' ).textContent = gt.textContent.length-1;
   d.getElementById( 'set' ).addEventListener('click', 
      function(){
         doGetCaretPosition( gt );
         process();
       }, false );

function doGetCaretPosition ( ctrl ) { 
	var CaretPos = 0;
	// IE Support
	if ( d.selection ) { 
		ctrl.focus ();
		var Sel = d.selection.createRange ();
		Sel.moveStart ( 'character', - ctrl.value.length); 
		CaretPos = Sel.text.length;
	}
	// Firefox support
	else  {
    if ( ctrl.selectionStart || ctrl.selectionStart === 0 )
		 CaretPos = ctrl.selectionStart;
     }
	return ( CaretPos ); 
}
 
function setCaretPosition( ctrl, pos ){
 
	if ( ctrl.setSelectionRange ) {
		 ctrl.focus();
		 ctrl.setSelectionRange( pos, pos );
	 }
	else {
    if ( ctrl.createTextRange ) {
		var range = ctrl.createTextRange();
		range.collapse( true );
		range.moveEnd( 'character', pos );
		range.moveStart( 'character', pos );
		range.select();
	  }
    }
 }
 
function process() {
	var nn = d.getElementById('no').value;
   if ( isNaN( nn )|| nn < 0 || nn > gt.textContent.length-1 || nn ==='' ){
        no.value='';
        no.placeholder = 'don\'t be silly now';
        return;
    }
	setCaretPosition( gt, nn );
  }
}( document ));